#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "fileio.h"
#include "dct.h"

/*
   anal_dct - Copyright 2006 by Michael Kohn
   http://www.mikekohn.net/  mike@mikekohn.net

   This code is NOT opensource and you may not use any of it
   in your own projects.

*/

int main(int argc, char *argv[])
{
FILE *in;
double dct[64];
int dct_int[64];
double highest_dct;
int highest_block_count;
int block[64];
int total_blocks;
int zero_blocks[65];
struct pic_info_t pic_info;
int threshold;
int x,y,c;

  printf("\nanal_dct - Copyright 2006 Michael Kohn\n"); 
  printf("http://www.mikekohn.net/  mike@mikekohn.net\n");
  printf("Date Version: May 11, 2006\n\n");

  if (argc!=3)
  {
    printf("Usage: anal_dct <image.bmp> <threshold>\n");
    exit(0);
  }

  in=fopen(argv[1],"rb");
  if (in==0)
  {
    printf("Could not open input file: %s\n",argv[1]);
    exit(0);
  }

  threshold=atoi(argv[2]);

  build_dct_matrix();
  memset(zero_blocks,0,sizeof(zero_blocks));
  total_blocks=0;
  highest_dct=0;
  highest_block_count=0;

/* print_double_matrix(dct_matrix); */

  pic_info.picture=0;
  parse_bmp(in,&pic_info);

  rgb2y(&pic_info);

  for (y=0; y<pic_info.height; y=y+8)
  {
    for (x=0; x<pic_info.width; x=x+8)
    {
      reorder(&pic_info,block,x,y);
      dct2d(block,dct);
      for (c=0; c<64; c++) dct_int[c]=(int)dct[c];

print_int_matrix(block);
/* print_double_matrix(dct); */
print_int_matrix(dct_int);

      for (c=0; c<64; c++)
      {
        if (abs(dct[c])>highest_dct) highest_dct=abs(dct[c]);
      }

      for (c=0; c<64; c++)
      {
        if (abs(dct_int[zig_zag[63-c]])>threshold) break;
        /* if (abs(dct_int[63-c])>threshold) break; */
      }

      zero_blocks[c]++;
      if (c>highest_block_count) highest_block_count=c;

printf("number of 0's: %d\n\n",c);

      total_blocks++;
    }
  }

  if (pic_info.picture!=0) free(pic_info.picture);
  if (pic_info.y!=0) free(pic_info.y);

/*
  printf("Zero Block Counts\n");
  printf("-----------------------------\n");

  for (c=highest_block_count-1; c>=0; c--)
  {
    printf("%d> %d\n",c+1,zero_blocks[c]);
  }

  printf("-----------------------------\n");
*/
  x=0;

  printf(" Zero Block Array: a = [");
  /* for (c=highest_block_count-1; c>=0; c--) */
  for (c=64; c>=0; c--)
  {
    printf(" %d",zero_blocks[c]);
    x+=zero_blocks[c]*c;
  }
  printf(" ]\n");

  printf("      Image Width: %d\n",pic_info.width);
  printf("     Image Height: %d\n",pic_info.height);
  printf(" Total DCT Blocks: %d\n",total_blocks);
  printf("Highest Value Dct: %f\n",highest_dct);
  printf("            Score: %d\n",(((x/total_blocks)*100)/64));
  printf("\n");

  fclose(in);

  return 0;
}

