#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "fileio.h"
#include "dct.h"

/*
   anal_dct - Copyright 2006 by Michael Kohn
   http://www.mikekohn.net/  mike@mikekohn.net

   This code is NOT opensource and you may not use any of it
   in your own projects.

*/

int zig_zag[64] =
{
   0,  1,  8, 16,  9,  2,  3, 10,
  17, 24, 32, 25, 18, 11,  4,  5,
  12, 19, 26, 33, 40, 48, 41, 34,
  27, 20, 13,  6,  7, 14, 21, 28,
  35, 42, 49, 56, 57, 50, 43, 36,
  29, 22, 15, 23, 30, 37, 44, 51,
  58, 59, 52, 45, 38, 31, 39, 46,
  53, 60, 61, 54, 47, 55, 62, 63
};

int print_double_matrix(double *matrix)
{
int i,j;

  for (j=0; j<8; j++)
  {
    for (i=0; i<8; i++)
    {
      printf("%03.3f ",matrix[i+(j*8)]);
    }
    printf("\n");
  }
  printf("\n");

  return 0;
}

int print_int_matrix(int *matrix)
{
int i,j;

  for (j=0; j<8; j++)
  {
    for (i=0; i<8; i++)
    {
      printf("%4d ",matrix[i+(j*8)]);
    }
    printf("\n");
  }
  printf("\n");

  return 0;
}

int transform_matrix(double *matrix_in, double *matrix_out)
{
int i,j;

  for (j=0; j<8; j++)
  {
    for (i=0; i<8; i++)
    {
      matrix_out[i+(j*8)]=matrix_in[j+(i*8)];
    }
  }

  return 0;
}

int build_dct_matrix()
{
double x,n,inc;
int i,j,ptr;

  i=0;
  x=1/sqrt(8);
  ptr=0;
  for (i=0; i<8; i++)
  {
    dct_matrix[ptr++]=x;
  }

  inc=0;

  for (j=1; j<8; j++)
  {
    n=j;
    inc=inc+2;

    for (i=0; i<8; i++)
    {
      dct_matrix[ptr++]=0.5*cos((n*M_PI)/(double)16);
      n=n+inc;
    }
  }

  return 0;
}

int dct2d(int *block, double *dct)
{
double dct1d[64];
double d0;
int i,j,a;
int dct_num;

  dct_num=0;

  for (j=0; j<8; j++)
  {
    for (i=0; i<8; i++)
    {
      d0=0;
      for (a=0; a<8; a++)
      {
        d0=d0+(dct_matrix[a+(j*8)]*(double)block[i+(a*8)]);
      }

      dct1d[j+(i*8)]=d0;  /* transform dct'd matrix */
    }
  }

/* print_double_matrix(dct1d); */

  for (j=0; j<8; j++)
  {
    for (i=0; i<8; i++)
    {
      d0=0;
      for (a=0; a<8; a++)
      {
        d0=d0+(dct_matrix[a+(j*8)]*(double)dct1d[i+(a*8)]);
      }

      dct[j+(i*8)]=d0;

/* printf("%d> %f\n",dct_num-1,dct[dct_num-1]); */
    }
  }

  return 0;
}

int reorder(struct pic_info_t *pic_info, int *block, int x0, int y0)
{
int x,y;
int ptr;

  for (ptr=0; ptr<64; ptr++)
  {
    x=zig_zag[ptr]%8;
    y=zig_zag[ptr]/8;

    block[ptr]=pic_info->y[x0+x+((y0+y)*pic_info->width)]-128;
  }

  return 0;
}

int rgb2y(struct pic_info_t *pic_info)
{
int l,ptr;
int r,g,b;
int y;

  l=pic_info->width*pic_info->height;
  pic_info->y=(int *)malloc(l*sizeof(int));

  for (ptr=0; ptr<l; ptr++)
  {
    r=(pic_info->picture[ptr]>>16)&255;
    g=(pic_info->picture[ptr]>>8)&255;
    b=pic_info->picture[ptr]&255;

    /* y=(0.257*(double)r) + (0.504*(double)g) + (0.098*(double)b) + 16; */
    y=(0.299*(double)r) + (0.587*(double)g) + (0.114*(double)b);

    if (y<0) y=0;
      else
    if (y>255) y=255;

/* printf("%d\n",y); */
    pic_info->y[ptr]=y;
  }

  return 0;
}




